#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX_NUM 10000     //   ߻

//  Լ 
      void Heuristic_Sort(int *a, int count);
void Select_Sort(int* a, int count);
void Bubble_Sort(int* a, int count);
void Insert_Sort(int* a, int count);
void Shell_Sort(int* a, int count);
void Quick_Sort(int* a, int count);

//  ߻ Լ
void Rand_Data(int* a);
int Random(int start, int end);

//ӵ  Լ
void Check_Speed(int num, char* str, int* a, int count);
int main(void)
{
	int data[MAX_NUM ];
       int i;

       char* str[ ] = { Heuristic", "Select", "Bubble", "Insert", 
                         "Shell", "Quick"};

       Rand_Data(data);
       
       for(i=0; i<5; i++)
            Check_Speed(i, str[i], data, MAX_NUM);

       return 0;
}
      void Heuristic_Sort(int *a, int right)
      {
                 int i;
                 int move_index(int*, int, int);
                 void array_swap(int*, int, int);
                 for(int j=1; j<=right; j++)
                 {
                       i=move_index(a, 0, j);
                       if(i!=j)
                             array_swap(a, i, j);
                 } 
       }
       void array_swap(int *a, int i, int j)
       {
                  int temp, k;
                  temp = a[j];
                  for(k=j-1 ; k>=i; k--)
                        a[k+1] = a[k];
                  a[i] = temp;
       }
       int move_index(int *a, int i, int j)
      {
                  int k=j;
                  while(k>i)
                 {
                      if(a[k-1] <= a[j])
                      return k;
                        k--;
                  }
                  return i;
        }

void Select_Sort(int *a, int count)
{
     int i, j;
     int min_value, min_index;
     
     for(i=0; i<count-1; i++)
     {
            min_index = i;
            min_value = a[i];
            for(j=i+1; j<count; j++)
            {
                if(min_value > a[j])
                {
                     min_index = j;
                     min_value = a[j];
                }
             }
            a[min_index] = a[i];
            a[i] = min_value;
     } 
}
void Bubble_Sort(int *a, int count)
{
     int i, j;
     int temp;
     
     for(i=0; i<count-1; i++)
     {
            for(j=1; j<count-i; j++)
            {
                if(a[j-1]  > a[j])
                {
                     temp = a[j-1];
                     a[j-1] = a[j];
                     a[j] = temp;
                }
             }
      } 
}
void Insert_Sort(int *a, int count)
{
     int i, j;
     int temp;
     
     for(i=1; i<count; i++)
     {
            temp = a[i];
            j = i;
            while((a[j-1] > temp) && (j>0))
            {
                a[j] = a[j-1];
                j = j-1;
            }
            a[j] = temp;
      } 
}
void Shell_Sort(int *a, int count)
{
     int i, j, inc, h;
     int temp;
     
     for(h=count/2; h>0; h/=2)
     {
           for(i=0; i<h; i++)
          {
               for(j=i+h; j<count; j+=h)
               {
                    temp = a[j];
                    inc = j;
                    while(inc > h-1 && a[inc-h] > temp)
                    {
                          a[inc] = a[inc-h];
                          inc = inc - h;
                    }
                    a[inc] = temp;
                }
           } 
      }
}
void Quick_Sort(int *a, int count)
{
     int i, j;
     int v, temp;
     
     if(count > 1)
     {
          v = a[count-1];
          i = -1;
          j = count - 1;
  
          for( ;  ; )
          {
               while( a[++i] < v );
               while( a[--j] > v );
               if(i >= j) break;
               temp = a[i];
               a[i] = a[j];
               a[j] = temp;
           }
           temp = a[i];
           a[i] = a[count-1];
           a[count-1] = temp;
           Quick_Sort(a, i);
           Quick_Sort(a+i+1, count-i-1);      
      }
}

void Rand_Data(int* a)
{
       int i;
       srand((unsigned)time(NULL)); //  ߻ ʱȭ
       for(i=0; i<MAX_NUM; i++)
       {
              a[i] = Random(1, MAX_NUM);   
              // 1 9999  ߻
       }
}
int Random(int start, int end)
{
       int rnd = 0;
       rnd = rand( ) % (end - start) + start;
       return rnd;
}
void Check_Speed(int num, char* str, int* a, int count)
{  
       clock_t  start, end;
       int temp[MAX_NUM];
       int i;

       for(i=0; i < MAX_NUM; i++)
             temp[i] = a[i];
       start = clock( ) ;

       switch(num)
       {
                      case 0:
                             Heuristic_Sort(temp, count);
                             break;             
              case 1;
                     Select_Sort(temp, count);
                     break;
              case 2;
                     Bubble_Sort(temp, count);
                     break;
              case 3;
                     Insert_Sort(temp, count);
                     break;
              case 4;
                     Shell_Sort(temp, count);
                     break;              
              case 5;
                     Quick_Sort(temp, count);
                     break;
        }

        end = clock( ) ; //  ð Ȯ
        printf(%10s  ӵ %5ldԴϴ.\n", str, end-start);
}        












